# e93 user preferences
# To modify your preferences, make changes to this file, and save.
# The changes made here will take effect after saving, and will be
# executed each time e93 is run.

# Set the default theme
ThemeSet			Traditional;									# see themes directories for choices (this is case sensitive)

# Adjust which side of the window vertical scroll bars are placed on
scrollbarplacement	Right;											# choices are: Left, Right (not case sensitive)

# Select which key is used as the "Command" key to access most menu items
commandkeyset		Ctrl;											# choices are: Ctrl, Window, Alt (not case sensitive)

# Uncomment the following line to set the screen location in pixels of
# the upper left corner of the root menu. This can be useful on
# multi-screen machines to get the menu showing up in the right place.
#moverootmenu X Y;

# Uncomment the following line to set the screen location in pixels
# where dialogs pop up. This can be useful on multi-screen machines
# to get the dialogs showing up in the right place.
#dialogcenter centerX centerY;

# Set checkboxes in the search dialog to default values.
# Change these to have them default whatever way you would like when e93 starts.
# Use '0' for unchecked, and '1' for checked.
set			::sd_backwards					0;							# do not search backwards by default at startup
set			::sd_wrapAround					0;							# do not wrap around by default at startup
set			::sd_ignoreCase					0;							# do not ignore case by default
set			::sd_limitScope					0;							# do not limit scope by default
set			::sd_selectionExpression		0;							# do not use selection expressions by default at startup
set			::sd_useSubexpression			0;							# do not use subexpression by default at startup
set			::sd_subexpressionIndex			0;							# set subexpression index to 0 by default at startup
set			::sd_replaceProc				0;							# do not treat replace text as procedure

# Set up default command used to print text in "buffer"
#set		::defaultPrintCommand			"a2ps -Pps18 --stdin=\$buffer -T\[gettabsize \$buffer\]";
#set		::defaultPrintCommand			"lpr -#1 -J=\$buffer";
set			::defaultPrintCommand			"enscript -B -h -c -T\[gettabsize \$buffer\] -f Courier7";

# Use this to change the font that windows open with.
set			::defaultFontName				"liberation mono:size=9";	# set the font used by default when opening windows (font names are not case sensitive)

# The variables below come into play when opening new windows, or when
# opening documents where e93 is unable to match the document name to a
# given set of syntax rules.
set			::defaultUtf8					1;							# set to 1 to open new windows in UTF-8 mode, set to 0 for plain ASCII
set			::defaultTabSize				4;							# default tab size for new windows
set			::defaultColorScheme			"e93";						# default color scheme for new windows (this is case sensitive)
set			::defaultSyntaxMap				"Plain Text";				# default syntax highlighting rules (this is case sensitive)

# NOTE: If you'd like to override the parameters used for any given syntax map,
# just uncomment the lines below, and modify them. Be sure to change the
# text inside the parenthesis to match the syntax map you'd like to override.
#set		::extensionUtf8(C/C++)			1;
#set		::extensionTabSize(C/C++)		4;
#set		::extensionColorScheme(C/C++)	"e93";

# Fonts used when glyphs cannot be located in the currently chosen font
fallbackfonts 		"symbola" "droid sans fallback";
