# Syntax coloring rules for 'C' and 'C++'
# March 19, 2000  TMS

addsyntaxmap "C/C++" \
{
	exp {e_types				"<(bool|char|char8_t|char16_t|char32_t|double|float|int|int8_t|int16_t|int32_t|int64_t|long|short|signed|uint8_t|uint16_t|uint32_t|uint64_t|unsigned|void|wchar_t)>"}
	exp {e_keywords				"<(alignas|alignof|and|and_eq|asm|atomic_cancel|atomic_commit|atomic_noexcept|auto|bitand|bitor|break|case|catch|class|co_await|co_return|co_yield|compl|concept|const|const_cast|consteval|constexpr|constinit|continue|decltype|default|delete|do|dynamic_cast|else|enum|explicit|export|extern|for|friend|goto|if|inline|mutable|namespace|new|noexcept|not|not_eq|nullptr|operator|or|or_eq|private|protected|public|reflexpr|register|reinterpret_cast|requires|return|sizeof|static|static_assert|static_cast|struct|switch|synchronized|template|thread_local|throw|try|typedef|typeid|typename|union|using|virtual|volatile|while|xor|xor_eq)>"}
	exp {e_values				"<(false|true|this|NULL|(\[0-9\]+(\[eE\]\[+\\-\]?\[0-9\]+\[FLfl\]?))|(((\[0-9\]+\\.\[0-9\]*)|(\\.\[0-9\]+))(\[eE\]\[+\\-\]?\[0-9\]+)?\[FLfl\]?)|(((0\[Bb\]\[0-1\]+)|(0\[0-7\]*)|(\[1-9\]\[0-9\]*)|(0\[Xx\]\[0-9A-Fa-f\]+))\[Uu\]?\[Ll\]{0,2}))>"}
	exp {e_directive_intro		"^\[ \\t\]*#"}
	exp {e_directive_include	"<include>"}
	exp {e_directive_others		"<(pragma|error|define|undef|if|ifdef|ifndef|else|elif|defined|endif|line)>"}
	exp {e_include_quote_start	"\\<"}
	exp {e_include_quote_end	"\\>"}
	exp {e_comment_start		"/\\*"}
	exp {e_comment_end			"\\*/"}
	exp {e_alt_comment_start	"//"}
	exp {e_end_of_line			"$"}
	exp {e_string_delimiter		"\""}
	exp {e_quoted_char			"(\\\\)(\[-\])"}
	exp {e_char_delimiter		"'"}
	exp {e_function_name		"<(\[A-Za-z_\]\[A-Za-z0-9_\]*)\[ \\t\]*\\("}
	exp {e_url					"<\[A-Za-z]\[0-9A-Za-z+.\\-\]*://\[0-9A-Za-z.\\-_/~@?=+&#:%\]+"}

	map {m_types				e_types					{}									$style_type			0				0}
	map {m_keywords				e_keywords				{}									$style_keyword		0				0}
	map {m_values				e_values				{}									$style_value		0				0}
	map {m_directive			e_directive_intro		{e_end_of_line}						$style_directive	0				0}
	map {m_directive_include	e_directive_include		{e_end_of_line}						$style_directive	0				0}
	map {m_directive_others		e_directive_others		{}									$style_directive	0				0}
	map {m_include_quote		e_include_quote_start	{e_include_quote_end}				$style_delimiter	$style_string	$style_delimiter}
	map {m_quoted_char			e_quoted_char:0			{e_quoted_char:1}					$style_delimiter	0				$style_char}
	map {m_comment				e_comment_start			{e_comment_end}						$style_comment		$style_comment	$style_comment}
	map {m_alt_comment			e_alt_comment_start		{e_end_of_line}						$style_comment		$style_comment	$style_comment}
	map {m_string				e_string_delimiter		{e_string_delimiter}				$style_delimiter	$style_string	$style_delimiter}
	map {m_char					e_char_delimiter		{e_char_delimiter}					$style_delimiter	$style_char		$style_delimiter}
	map {m_function_name		e_function_name:0		{}									$style_function		0				0}
	map {m_url					e_url					{}									$style_link			0				0}

	at {m_directive				{m_quoted_char m_directive_include m_directive_others m_types m_keywords m_values m_comment m_alt_comment m_string m_char}}
	at {m_directive_include		{m_quoted_char m_comment m_alt_comment m_string m_include_quote m_char}}
	at {m_include_quote			{m_quoted_char}}
	at {m_string				{m_quoted_char}}
	at {m_char					{m_quoted_char}}
	at {m_comment				{m_url}}
	at {m_alt_comment			{m_url}}

	root {m_quoted_char m_directive m_types m_keywords m_values m_comment m_alt_comment m_string m_char m_function_name}
}

set	::extensionHuntExpression(C/C++)	{^((.*\.c)|(.*\.h)|(.*\.cpp)|(.*\.C)|(.*\.c\+\+)|(.*\.cc)|(.*\.hpp))$}
set	::extensionUtf8(C/C++)				1
set	::extensionTabSize(C/C++)			4
set	::extensionColorScheme(C/C++)		"e93"
set	::extensionMapName(C/C++)			"C/C++"
