// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

bool EditorBufferBusy(EDITOR_BUFFER *buffer);
void EditorBufferBusyClear(EDITOR_BUFFER *buffer);
void EditorBufferBusySet(EDITOR_BUFFER *buffer);
EDITOR_BUFFER *EditorBufferGetNext(EDITOR_BUFFER *buffer);
EDITOR_BUFFER *EditorBufferGetFirst();
EDITOR_BUFFER *EditorBufferLocate(const char *bufferName);
void EditorBufferHandleRelease(EDITOR_BUFFER_HANDLE *handle);
void EditorBufferHandleGrab(EDITOR_BUFFER_HANDLE *handle,EDITOR_BUFFER *buffer);
EDITOR_BUFFER *EditorBufferGetFromHandle(EDITOR_BUFFER_HANDLE *handle);
void EditorBufferHandleInit(EDITOR_BUFFER_HANDLE *handle);
bool EditorBufferClear(EDITOR_BUFFER *buffer);
void EditorBufferTaskDisconnect(EDITOR_BUFFER *buffer);
bool EditorBufferTaskEofWrite(EDITOR_BUFFER *buffer);
bool EditorBufferTaskDataWrite(EDITOR_BUFFER *buffer,const uint8_t *taskData,uint64_t taskDataLength);
bool EditorBufferHasTask(EDITOR_BUFFER *buffer);
bool EditorBufferTaskKill(EDITOR_BUFFER *buffer);
bool EditorBufferTaskSpawn(EDITOR_BUFFER *buffer,const char *commandString);
bool EditorBufferRevert(EDITOR_BUFFER *buffer);
bool EditorBufferSaveTo(EDITOR_BUFFER *buffer,const char *path);
bool EditorBufferSaveAs(EDITOR_BUFFER *buffer,const char *path);
bool EditorBufferSave(EDITOR_BUFFER *buffer);
EDITOR_BUFFER *EditorBufferNew(const char *bufferName);
void EditorBufferClose(EDITOR_BUFFER *buffer);
EDITOR_BUFFER *EditorBufferOpen(const char *path);
void EditorBufferUnInit();
bool EditorBufferInit();
