// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

// all the includes needed to compile e93
#define		__STDC_FORMAT_MACROS		// some older inttypes.h files won't give us definitions if this isn't defined

// system include files

#include	<stdio.h>
#include	<stdarg.h>
#include	<stdlib.h>
#include	<stdint.h>
#include	<inttypes.h>
#include	<errno.h>
#include	<fcntl.h>
#include	<time.h>
#include	<ctype.h>
#include	<malloc.h>
#include	<memory.h>
#include	<string.h>
#include	<limits.h>
#include	<locale.h>

#include	<tcl.h>

// deal with Tcl changing the way this works in newer versions
#if ((TCL_MAJOR_VERSION<8)||((TCL_MAJOR_VERSION==8)&&(TCL_MINOR_VERSION<6)))&&(!defined(Tcl_GetErrorLine))
#define	Tcl_GetErrorLine(interpreter)	interpreter->errorLine
#endif

#include	"defines.h"
#include	"tokens.h"
#include	"named_list.h"
#include	"background.h"
#include	"c_array.h"
#include	"sparse_array.h"
#include	"text.h"
#include	"utf8.h"
#include	"code_point.h"
#include	"platform_defs.h"
#include	"key_bind.h"
#include	"shell.h"
#include	"shell_cmd.h"
#include	"channels.h"
#include	"editor_buffer.h"
#include	"var_bind.h"
#include	"view_color_scheme.h"
#include	"view_color_scheme_fonts.h"
#include	"views.h"
#include	"document_window.h"
#include	"syntax.h"
#include	"edit.h"
#include	"select.h"
#include	"style.h"
#include	"regex.h"
#include	"search.h"
#include	"clipboard.h"
#include	"undo.h"
#include	"abort.h"
#include	"error.h"
#include	"globals.h"
