// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef struct keyBinding KEY_BINDING;

char *KeyBindTextGet(KEY_BINDING *binding);
void KeyBindEditorKeyGet(KEY_BINDING *binding,uint32_t *modifiers,uint32_t *keyCode);
KEY_BINDING *KeyBindLocateNext(KEY_BINDING *currentBinding);
KEY_BINDING *KeyBindLocateFirst();
KEY_BINDING *KeyBindLocate(uint32_t modifiers,uint32_t keyCode);
bool KeyBindDelete(uint32_t modifiers,uint32_t keyCode);
bool KeyBindCreate(uint32_t modifiers,uint32_t keyCode,char *dataText);
bool KeyBindModifierNameToIndex(const char *name,uint32_t *modifierIndex);
uint32_t KeyBindModifierIndexToName(uint32_t modifierIndex,char *stringBuffer,uint32_t bufferLength);
bool KeyBindNameToKey(const char *name,uint32_t *modifiers,uint32_t *keyCode);
uint32_t KeyBindKeyToName(uint32_t modifiers,uint32_t keyCode,char *stringBuffer,uint32_t bufferLength);
void KeyBindUnInit();
bool KeyBindInit();
