# Copyright © 1999, 2000 Core Technologies.
#
# This file is part of e93.
#
# e93 is free software; you can redistribute it and/or modify
# it under the terms of the e93 LICENSE AGREEMENT.
#
# e93 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# e93 LICENSE AGREEMENT for more details.
#
# You should have received a copy of the e93 LICENSE AGREEMENT
# along with e93; see the file "LICENSE.TXT".

# ----------------------------------------------------
# Machine specific portion of make process for e93
# You may need to edit this file to get e93 to compile
# for your platform
# This will be made more automatic in the future. At
# the moment, it is set up for most Linux machines...
# ----------------------------------------------------

# Set paths used to install e93
# e93 will install its single executable "e93" in $BIN_PATH_PREFIX
# and it will place its resources in $LIB_PATH_PREFIX
BIN_PATH_PREFIX=/usr/local/bin
LIB_PATH_PREFIX=/usr/local/lib/e93lib

# ----------------------------------------------------
# The following lines may need to be altered if the X include and library
# files are located elsewhere on your system:
X_INCLUDE=-I/usr/X11R6/include -I/usr/include/freetype2
X_LIB=-L/usr/X11R6/lib -lX11 -lXrender -lXmu -lXinerama -lXft -lfontconfig

# ----------------------------------------------------
# The following lines may need to be altered if the libpng include and
# library files are located elsewhere on your system:
PNG_INCLUDE=
PNG_LIB=-lpng

# ----------------------------------------------------
# The following lines may need to be altered if the Tcl
# files are located elsewhere on your system:
# uncomment and change if you want to link with specific versions of Tcl
TCL_VERSION=8.6
TCL_INCLUDE=-I/usr/include/tcl$(TCL_VERSION)
TCL_LIB=-L/usr/lib/x86_64-linux-gnu -ltcl$(TCL_VERSION)

# ----------------------------------------------------

# if your system needs some extra libraries, add them here:
EXTRALIBS=-lm -lpthread

# set compiler to use
CC=gcc


# set some compiler options
OPTIONS=-O3 -Wall -x c++
#OPTIONS=-Wall -x c++ -g
