// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef void buttonPressedFunction(DIALOG_ITEM *item);

typedef struct buttonDescriptor									// describes a button to creation routines
{
	DIALOG_POSITION_FUNCTION
		*positionFunction;										// function which is used to position this item in the dialog
	const char
		*buttonName;											// text to draw for the button
	const GUI_IMAGE
		*image;													// image to draw for the button
	EDITOR_COLOR
		activeBackgroundColor,									// colors needed for button
		activeForegroundColor,
		inactiveBackgroundColor,
		inactiveForegroundColor,
		pressedBackgroundColor,
		pressedForegroundColor,
		shadowColor;
	const char
		*fontName;												// font to draw the button in
	bool
		hasKey;													// true if this button has a key code associated with it
	uint32_t
		keyCode;												// equivalent key code for this button
	bool
		*pressedState;											// boolean set to true if button pressed
	buttonPressedFunction
		*pressedFunction;										// routine called when the button has been pressed
} BUTTON_DESCRIPTOR;

void ButtonItemPress(DIALOG_ITEM *item);
void ButtonItemDimensions(DIALOG_ITEM *item,uint32_t *width,uint32_t *height);
DIALOG_ITEM *ButtonItemCreate(DIALOG *dialog,void *descriptor);
