// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef void checkBoxPressedFunction(DIALOG_ITEM *item);

typedef struct checkBoxDescriptor			// describes a check box to creation routines
{
	DIALOG_POSITION_FUNCTION
		*positionFunction;					// function which is used to position this item in the dialog
	const char
		*checkBoxName;
	EDITOR_COLOR
		activeBackgroundColor,				// background when active
		activeForegroundColor,				// foreground when active
		inactiveBackgroundColor,			// background when inactive
		inactiveForegroundColor;			// foreground when inactive
	const char
		*fontName;							// font to draw the text in
	bool
		active;								// tells if the checkbox is "active" (can be clicked on, and drawn active)
	bool
		hasKey;								// true if this check box has a key code associated with it
	uint32_t
		keyCode;							// equivalent key code for this check box
	bool
		*pressedState;						// boolean set to true if check box checked
	checkBoxPressedFunction
		*pressedFunction;					// routine called when the check box has been pressed (if NULL, won't be called)
} CHECK_BOX_DESCRIPTOR;

bool CheckBoxItemCheckedGet(DIALOG_ITEM *item);
void CheckBoxItemCheckedSet(DIALOG_ITEM *item,bool checked);
bool CheckBoxItemActiveGet(DIALOG_ITEM *item);
void CheckBoxItemActiveSet(DIALOG_ITEM *item,bool active);
DIALOG_ITEM *CheckBoxItemCreate(DIALOG *dialog,void *descriptor);
