// Color handling
// Copyright © 2000-2020 Core Technologies.

// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

#include	"includes.h"

bool PlatformColorNameToColor(const char *colorName,EDITOR_COLOR *color)
// Convert a platform specific color name into an editor color.
// If the name does not map to a color, return false.
// NOTE: it is reasonable for this routine to always return
// false on machines which do not assign names to colors.
{
	XColor
		exactResult,
		screenResult;

	if(XLookupColor(xDisplay,xColorMap32,colorName,&exactResult,&screenResult))
	{
		*color=(0xFF<<24)|((screenResult.red>>8)<<16)|((screenResult.green>>8)<<8)|(screenResult.blue>>8);
		return(true);
	}
	return(false);
}

void ColorsUnInit()
// Undo what ColorsInit did.
{
}

bool ColorsInit()
// Initialize color handling.
// If there is a fatal problem, ErrorSet, return false.
{
	return(true);
}
