// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

uint32_t FontText32Width(EDITOR_FONT *font,const uint32_t *text,uint32_t length);
uint32_t FontTextUtf8Width(EDITOR_FONT *font,const char *text,uint32_t length);
bool FontCodePoint32Width(EDITOR_FONT *font,uint32_t codePoint,uint32_t *width);
int FontText32Draw(EDITOR_FONT *font,GUI_IMAGE *imageBuffer,EDITOR_COLOR color,int x,int y,const uint32_t *text,uint32_t length);
int FontTextUtf8Draw(EDITOR_FONT *font,GUI_IMAGE *imageBuffer,EDITOR_COLOR color,int x,int y,const char *text,uint32_t length);
void FontHeightsGet(EDITOR_FONT *font,uint32_t *ascent,uint32_t *descent);
void PlatformFontCompositeNameSplit(const char *compositeName,char *familyName,uint32_t *size,bool *bold,bool *oblique);
void PlatformFontComponentNameJoin(const char *familyName,uint32_t size,bool bold,bool oblique,char *compositeName);
const char *PlatformFontCompositeNameGet(EDITOR_FONT *font);
void PlatformFontFree(EDITOR_FONT *font);
EDITOR_FONT *PlatformFontLoad(const char *compositeName);
EDITOR_FONT *PlatformFontDuplicate(EDITOR_FONT *original);
bool FontsFallbackListAppend(const char *familyName);
void FontsFallbackListClear();
void FontsUnInit();
bool FontsInit();
