// Globals needed by the GUI
// Copyright © 2000-2020 Core Technologies.

// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

#include	"includes.h"

Display
	*xDisplay;				// the x display that the editor is currently running on
int
	xScreenNum;				// the screen number on xDisplay where we will be opening windows
XVisualInfo
	xVisualInfo32;			// 32-bit visual (used for offscreen drawing)
Colormap
	xColorMap32;			// colormap for offscreen drawing

bool
	xFail;					// set by X's error vector (so we can tell when certain routines which neglect to return status fail)

Cursor
	arrowCursor,			// arrow cursor
	caretCursor;			// insertion cursor definition

uint32_t
	showingBusy;			// tells depth of busy being shown

bool
	verticalScrollBarOnLeft;	// true if the vertical scroll bar should be placed at the left hand side of document windows

Atom
	wmNameAtom,				// atoms defined at startup
	iconNameAtom,
	iconAtom,
	targetsAtom,
	selectionAtom,
	utf8StringAtom,
	incrAtom,
	takeFocusAtom,
	deleteWindowAtom;

EDITOR_WINDOW
	*windowListHead;		// head of the window list

EDITOR_WINDOW
	*rootMenuWindow;		// this keeps track of the root of the menu window hierarchy (also base window for application)

bool
	timeToQuit;
