// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

// GUI includes

// standard C

#include	<stdio.h>
#include	<stdarg.h>
#include	<stdlib.h>
#include	<stdint.h>
#include	<errno.h>
#define		_BSD_SIGNALS
#include	<signal.h>
#include	<unistd.h>
#include	<fcntl.h>
#include	<time.h>
#include	<ctype.h>
#include	<memory.h>
#include	<string.h>
#include	<limits.h>
#include	<poll.h>
#include	<sys/types.h>
#include	<sys/param.h>
#include	<sys/stat.h>
#include	<sys/time.h>
#include	<sys/wait.h>
#include	<dirent.h>
#include	<pwd.h>
#include	<termios.h>

// PNG
#include	<png.h>		// include png.h before Xlib, otherwise it complains

// Xlib

#include	<fontconfig/fontconfig.h>
#include	<X11/Xatom.h>
#include	<X11/Xft/Xft.h>
#include	<X11/Xlib.h>
#include	<X11/Xutil.h>
#include	<X11/XKBlib.h>
#include	<X11/cursorfont.h>
#include	<X11/keysym.h>
#include	<X11/extensions/Xinerama.h>
#include	<X11/Xmu/Atoms.h>

// Tcl
#include	<tcl.h>

// high level e93

#include	"../includes.h"

// prototypes, etc for our routines

#include	"defines.h"
#include	"init.h"
#include	"string_list.h"
#include	"image.h"
#include	"image_file.h"
#include	"image_asset.h"
#include	"fonts.h"
#include	"font_list.h"
#include	"colors.h"
#include	"dialogs.h"
#include	"events.h"
#include	"menus.h"
#include	"document_window.h"
#include	"window.h"
#include	"views.h"
#include	"tasks.h"
#include	"xclipboard.h"
#include	"misc.h"
#include	"mem_funcs.h"
#include	"glob.h"
#include	"button.h"
#include	"popup.h"
#include	"check_box.h"
#include	"scroll_bar.h"
#include	"static_text.h"
#include	"text_box.h"
#include	"list_box.h"
#include	"separate.h"
#include	"shell_cmd.h"

#include	"globals.h"
