// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef void listBoxPressedFunction(DIALOG_ITEM *item);

typedef struct listBoxDescriptor		// describes a list box to creation routines
{
	DIALOG_POSITION_FUNCTION
		*positionFunction;				// function which is used to position this item in the dialog
	EDITOR_COLOR
		activeBackgroundColor,			// color to use when drawing background during focus
		activeForegroundColor,			// color to use when drawing foreground during focus
		activeBorderColor,				// color to draw around the border during focus
		inactiveBackgroundColor,		// color to use when drawing background during non focus
		inactiveForegroundColor,		// color to use when drawing foreground during non focus
		inactiveBorderColor;			// color to draw around the border during non focus
	uint32_t
		numElements;					// tells how many elements are in the list
	const char
		**listElements;					// pointer to array of pointers to items in the list
	bool
		*selectedElements;				// pointer to array of bools which tell which items should be selected at startup
	const char
		*fontName;						// font to use for list items
	listBoxPressedFunction
		*pressedFunction;				// routine called when the list items have been chosen (by double clicking in the list)
} LIST_BOX_DESCRIPTOR;


void ListBoxItemListsReset(DIALOG_ITEM *item,uint32_t numElements,const char **list,bool *selectedElements);
DIALOG_ITEM *ListBoxItemCreate(DIALOG *dialog,void *descriptor);
