// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef void popupPressedFunction(DIALOG_ITEM *item);

typedef struct popupDescriptor			// describes a popup menu to creation routines
{
	DIALOG_POSITION_FUNCTION
		*positionFunction;				// function which is used to position this item in the dialog
	EDITOR_COLOR
		activeBackgroundColor,			// background when active
		activeForegroundColor,			// foreground when active
		inactiveBackgroundColor,		// background when inactive
		inactiveForegroundColor,		// foreground when inactive
		borderColor;					// color for the borders
	const char
		*fontName;						// font to use for popup items
	bool
		active;							// tells if the popup is "active" (can be clicked on, and drawn active)
	uint32_t
		numElements;					// tells how many elements are in the list
	const char
		**listElements;					// pointer to array of pointers to items in the list
	uint32_t
		*currentElement;				// currently selected element in the popup (updated by popup tracking)
	popupPressedFunction
		*pressedFunction;				// routine called when an item has been chosen
} POPUP_DESCRIPTOR;

bool PopupItemActiveGet(DIALOG_ITEM *item);
void PopupItemActiveSet(DIALOG_ITEM *item,bool active);
DIALOG_ITEM *PopupItemCreate(DIALOG *dialog,void *descriptor);
