// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef struct staticTextDescriptor								// describes static text to creation routines
{
	DIALOG_POSITION_FUNCTION
		*positionFunction;										// function which is used to position this item in the dialog
	EDITOR_COLOR
		foregroundColor;										// color to use when drawing foreground
	const char
		*string;
	const char
		*fontName;
} STATIC_TEXT_DESCRIPTOR;

void StaticTextItemTextReset(DIALOG_ITEM *item,char *newString);
void StaticTextItemRectangleGet(DIALOG_ITEM *item,EDITOR_RECT *rect);
uint32_t StaticTextItemHeightGet(DIALOG_ITEM *item,uint32_t width);
DIALOG_ITEM *StaticTextItemCreate(DIALOG *dialog,void *descriptor);
