// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef struct textBoxDescriptor		// describes a list box to creation routines
{
	DIALOG_POSITION_FUNCTION
		*positionFunction;				// function which is used to position this item in the dialog
	EDITOR_BUFFER
		*buffer;						// the buffer on which to view
	uint32_t
		tabSize;						// columns per tab
	const char
		*fontName;						// name of the font used for the view
	const char
		*colorSchemeName;				// name of the color scheme used for the view
	EDITOR_COLOR
		activeBorderColor,				// colors needed for text box items
		inactiveBorderColor;
} TEXT_BOX_DESCRIPTOR;

DIALOG_ITEM *TextBoxItemCreate(DIALOG *dialog,void *descriptor);
