// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

#define MAX_REGISTERS				10				// maximum number of registers that will be remembered

typedef struct compiledExpression COMPILED_EXPRESSION;

void RegexPrintCompiledExpression(COMPILED_EXPRESSION *expression);
void RegexFree(COMPILED_EXPRESSION *expression);
COMPILED_EXPRESSION *RegexCompileStream(TEXT_STREAM *stream,bool ignoreCase);
COMPILED_EXPRESSION *RegexCompileText(uint8_t *expression,uint64_t numBytes,bool ignoreCase);
bool RegexRegisterMatchGet(COMPILED_EXPRESSION *compiledExpression,uint32_t expRegisterIndex,TEXT_STREAM *startStream,uint64_t *matchLength);
bool RegexSearchForward(const TEXT_STREAM *stream,COMPILED_EXPRESSION *compiledExpression,bool useUtf8,bool leftEdge,bool rightEdge,uint64_t numToSearchStart,uint64_t numToSearch,bool *foundMatch,TEXT_STREAM *startStream,TEXT_STREAM *endStream,ABORT_TEST_FUNCTION *abortFunction);
bool RegexSearchBackward(const TEXT_STREAM *stream,COMPILED_EXPRESSION *compiledExpression,bool useUtf8,bool leftEdge,bool rightEdge,uint64_t numToSearch,bool *foundMatch,TEXT_STREAM *startStream,TEXT_STREAM *endStream,ABORT_TEST_FUNCTION *abortFunction);
void RegexHuntBackToFarthestPossibleStart(const TEXT_STREAM *stream,COMPILED_EXPRESSION *compiledExpression,uint64_t *numBack,TEXT_STREAM *endStream);
