// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

uint32_t SearchToUpper(uint32_t codePoint);
uint32_t SearchToLower(uint32_t codePoint);
bool LiteralMatch(const TEXT_STREAM *stream,const TEXT_STREAM *forTextStream,uint64_t numToSearch,bool useUtf8,bool ignoreCase,TEXT_STREAM *endStream);
bool SearchForwardLiteral(const TEXT_STREAM *stream,const TEXT_STREAM *forTextStream,uint64_t forTextLength,uint64_t numToSearch,bool useUtf8,bool ignoreCase,bool *foundMatch,TEXT_STREAM *startStream,TEXT_STREAM *endStream,ABORT_TEST_FUNCTION *abortFunction);
bool SearchBackwardLiteral(const TEXT_STREAM *stream,const TEXT_STREAM *forTextStream,uint64_t forTextLength,uint64_t numToSearch,bool useUtf8,bool ignoreCase,bool *foundMatch,TEXT_STREAM *startStream,TEXT_STREAM *endStream,ABORT_TEST_FUNCTION *abortFunction);
bool EditorFind(EDITOR_BUFFER *buffer,SELECTION_UNIVERSE *selectionUniverse,TEXT_UNIVERSE *searchForText,bool useUtf8,bool backward,bool wrapAround,bool ignoreCase,bool limitScope,bool selectionExpr,bool useSubexpression,uint32_t subexpressionIndex,bool *foundMatch,SELECTION_UNIVERSE *resultSelectionUniverse,ABORT_TEST_FUNCTION *abortFunction);
bool EditorFindAll(EDITOR_BUFFER *buffer,SELECTION_UNIVERSE *selectionUniverse,TEXT_UNIVERSE *searchForText,bool useUtf8,bool backward,bool wrapAround,bool ignoreCase,bool limitScope,bool selectionExpr,bool useSubexpression,uint32_t subexpressionIndex,bool *foundMatch,SELECTION_UNIVERSE *resultSelectionUniverse,ABORT_TEST_FUNCTION *abortFunction);
bool EditorReplace(EDITOR_BUFFER *buffer,SELECTION_UNIVERSE *selectionUniverse,TEXT_UNIVERSE *searchForText,TEXT_UNIVERSE *replaceWithText,bool useUtf8,bool backward,bool wrapAround,bool ignoreCase,bool limitScope,bool selectionExpr,bool useSubexpression,uint32_t subexpressionIndex,bool replaceProc,bool *foundMatch,SELECTION_UNIVERSE *resultSelectionUniverse,ABORT_TEST_FUNCTION *abortFunction);
bool EditorReplaceAll(EDITOR_BUFFER *buffer,SELECTION_UNIVERSE *selectionUniverse,TEXT_UNIVERSE *searchForText,TEXT_UNIVERSE *replaceWithText,bool useUtf8,bool backward,bool wrapAround,bool ignoreCase,bool limitScope,bool selectionExpr,bool useSubexpression,uint32_t subexpressionIndex,bool replaceProc,bool *foundMatch,SELECTION_UNIVERSE *resultSelectionUniverse,ABORT_TEST_FUNCTION *abortFunction);
