// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

void SelectionDump(SELECTION_UNIVERSE *universe);
void SelectionDeleteAll(SELECTION_UNIVERSE *universe);
void SelectionRangeDelete(SELECTION_UNIVERSE *universe,uint64_t startPosition,uint64_t numElements);
bool SelectionRangeInsert(SELECTION_UNIVERSE *universe,uint64_t startPosition,uint64_t numElements);
bool SelectionRangeClear(SELECTION_UNIVERSE *universe,uint64_t startPosition,uint64_t numElements);
bool SelectionRangeSet(SELECTION_UNIVERSE *universe,uint64_t startPosition,uint64_t numElements);
bool SelectionAtOrAfterPositionGet(SELECTION_UNIVERSE *universe,uint64_t position,uint64_t *startPosition,uint64_t *numElements);
bool SelectionAtOrBeforePositionGet(SELECTION_UNIVERSE *universe,uint64_t position,uint64_t *startPosition,uint64_t *numElements);
bool SelectionRangeGet(SELECTION_UNIVERSE *universe,uint64_t position,uint64_t *startPosition,uint64_t *numElements,bool *isActive);
bool SelectionAtPositionGet(SELECTION_UNIVERSE *universe,uint64_t position);
uint64_t SelectionSegmentsGet(SELECTION_UNIVERSE *universe);
bool SelectionIsEmpty(SELECTION_UNIVERSE *universe);
void SelectionEndPositionsGet(SELECTION_UNIVERSE *universe,uint64_t *startPosition,uint64_t *endPosition);
uint64_t SelectionOccupiedElementsGet(SELECTION_UNIVERSE *universe);
uint64_t SelectionCursorPositionGet(SELECTION_UNIVERSE *universe);
void SelectionCursorPositionSet(SELECTION_UNIVERSE *universe,uint64_t position);
void SelectionAdjustForChange(SELECTION_UNIVERSE *universe,uint64_t startOffset,uint64_t oldEndOffset,uint64_t newEndOffset);
bool SelectionUniverseCopy(SELECTION_UNIVERSE *sourceUniverse,SELECTION_UNIVERSE *destUniverse);
bool SelectionUniverseOr(SELECTION_UNIVERSE *sourceUniverse,SELECTION_UNIVERSE *destUniverse);
bool SelectionUniverseSourceNotAnd(SELECTION_UNIVERSE *sourceUniverse,SELECTION_UNIVERSE *destUniverse);
bool SelectionUniverseDestNotAnd(SELECTION_UNIVERSE *sourceUniverse,SELECTION_UNIVERSE *destUniverse);
bool SelectionUniverseAnd(SELECTION_UNIVERSE *sourceUniverse,SELECTION_UNIVERSE *destUniverse);
bool SelectionUniverseXor(SELECTION_UNIVERSE *sourceUniverse,SELECTION_UNIVERSE *destUniverse);
EDITOR_MARK *SelectionUniverseMarkGet(SELECTION_UNIVERSE *universe);
void SelectionUniverseClose(SELECTION_UNIVERSE *universe);
SELECTION_UNIVERSE *SelectionUniverseOpen();
MARK_VISIBILITY *MarkVisibilityLocateInView(EDITOR_VIEW *view,EDITOR_MARK *mark);
void MarksVisibleUnlinkFromView(EDITOR_VIEW *view);
void EditorMarkVisibleClear(EDITOR_MARK *mark,EDITOR_VIEW *view);
bool EditorMarkVisibleSet(EDITOR_MARK *mark,EDITOR_VIEW *view,EDITOR_COLOR backgroundColor);
EDITOR_MARK *EditorMarkLocate(EDITOR_BUFFER *buffer,const char *markName);
void EditorMarkClose(EDITOR_BUFFER *buffer,EDITOR_MARK *mark);
EDITOR_MARK *EditorMarkOpen(EDITOR_BUFFER *buffer,const char *markName);
