// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

typedef struct expressionPiece EXPRESSION_PIECE;
typedef struct expressionPieceList EXPRESSION_PIECE_LIST;
typedef struct syntaxExpression SYNTAX_EXPRESSION;
typedef struct syntaxStyleMapping SYNTAX_STYLE_MAPPING;
typedef struct syntaxStyleMappingList SYNTAX_STYLE_MAPPING_LIST;
typedef struct syntaxMap SYNTAX_MAP;

bool SyntaxMapUpdate(EDITOR_BUFFER *buffer,uint64_t startOffset,uint64_t endOffset,uint64_t numBytes);
bool SyntaxMapRegenerate(EDITOR_BUFFER *buffer);
SYNTAX_MAP *SyntaxMapInstanceParentGet(SYNTAX_INSTANCE *instance);
void SyntaxMapInstanceClose(SYNTAX_INSTANCE *instance);
SYNTAX_INSTANCE *SyntaxMapInstanceOpen(SYNTAX_MAP *map,EDITOR_BUFFER *buffer);
void SyntaxMapMappingListRemove(SYNTAX_STYLE_MAPPING_LIST *list);
SYNTAX_STYLE_MAPPING_LIST *SyntaxMapMappingListElementAdd(SYNTAX_STYLE_MAPPING_LIST **listHead,SYNTAX_STYLE_MAPPING *mapping);
SYNTAX_STYLE_MAPPING_LIST *SyntaxMapBetweenListElementAdd(SYNTAX_STYLE_MAPPING *mapping,SYNTAX_STYLE_MAPPING *betweenMapping);
SYNTAX_STYLE_MAPPING_LIST *SyntaxMapRootListElementAdd(SYNTAX_MAP *map,SYNTAX_STYLE_MAPPING *rootMapping);
SYNTAX_STYLE_MAPPING *SyntaxMapStyleMappingLocate(SYNTAX_MAP *map,const char *name);
void SyntaxMapMappingStartExpressionPieceSet(SYNTAX_STYLE_MAPPING *mapping,EXPRESSION_PIECE *startExpressionPiece);
void SyntaxMapExpressionListRemove(EXPRESSION_PIECE_LIST *list);
EXPRESSION_PIECE_LIST *SyntaxMapMappingEndExpressionPieceAdd(SYNTAX_STYLE_MAPPING *mapping,EXPRESSION_PIECE *endExpressionPiece);
void SyntaxMapMappingStylesSet(SYNTAX_STYLE_MAPPING *mapping,uint32_t startStyle,uint32_t betweenStyle,uint32_t endStyle);
void SyntaxMapMappingRemove(SYNTAX_MAP *map,SYNTAX_STYLE_MAPPING *mapping);
SYNTAX_STYLE_MAPPING *SyntaxMapMappingAdd(SYNTAX_MAP *map,const char *mappingName);
EXPRESSION_PIECE *SyntaxMapExpressionLocatePiece(SYNTAX_EXPRESSION *expression,bool useRegisterMatch,uint32_t registerIndex);
void SyntaxMapExpressionRemovePiece(SYNTAX_EXPRESSION *expression,EXPRESSION_PIECE *piece);
EXPRESSION_PIECE *SyntaxMapExpressionAddPiece(SYNTAX_EXPRESSION *expression,bool useRegisterMatch,uint32_t registerIndex);
SYNTAX_EXPRESSION *SyntaxMapExpressionLocate(SYNTAX_MAP *map,const char *name);
void SyntaxMapExpressionRemove(SYNTAX_MAP *map,SYNTAX_EXPRESSION *expression);
SYNTAX_EXPRESSION *SyntaxMapExpressionAdd(SYNTAX_MAP *map,const char *expressionName,const char *expressionText);
const char *SyntaxMapNameGet(SYNTAX_MAP *map);
SYNTAX_MAP *SyntaxMapLocateNext(SYNTAX_MAP *map);
SYNTAX_MAP *SyntaxMapLocate(char *name);
void SyntaxMapUnlink(SYNTAX_MAP *map);
bool SyntaxMapLink(SYNTAX_MAP *map);
void SyntaxMapClose(SYNTAX_MAP *map);
SYNTAX_MAP *SyntaxMapOpen(char *name);
EDITOR_BUFFER *SyntaxMapLocateNextEditorBuffer(SYNTAX_MAP *map,EDITOR_BUFFER *buffer);
SYNTAX_MAP *SyntaxMapGetAssigned(EDITOR_BUFFER *buffer);
bool SyntaxMapAssign(EDITOR_BUFFER *buffer,SYNTAX_MAP *map);
void SyntaxMapsUnInit();
bool SyntaxMapsInit();
