// This file is part of e93.
//
// e93 is free software; you can redistribute it and/or modify
// it under the terms of the e93 LICENSE AGREEMENT.
//
// e93 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// e93 LICENSE AGREEMENT for more details.
//
// You should have received a copy of the e93 LICENSE AGREEMENT
// along with e93; see the file "LICENSE.TXT".

void ViewMetaChangeCallback(EDITOR_VIEW *view);
void ViewsMetaChangeCallbacks(EDITOR_BUFFER *buffer);
bool ViewUtf8Get(EDITOR_VIEW *view);
bool ViewUtf8Set(EDITOR_VIEW *view,bool useUtf8);
uint32_t ViewTabSizeGet(EDITOR_VIEW *view);
bool ViewTabSizeSet(EDITOR_VIEW *view,uint32_t size);
void ViewFontNameGet(EDITOR_VIEW *view,char *fontName);
void ViewFontNameSet(EDITOR_VIEW *view,const char *fontName);
void ViewColorsGet(EDITOR_VIEW *view,EDITOR_COLOR *backgroundColor,EDITOR_COLOR *foregroundColor);
void ViewColorsSet(EDITOR_VIEW *view,EDITOR_COLOR backgroundColor,EDITOR_COLOR foregroundColor);
bool ViewColorSchemeSet(EDITOR_VIEW *view,const char *colorSchemeName);
void ViewsStyleAreaChangeEnd(EDITOR_BUFFER *buffer);
void ViewsStyleAreaChangeStart(EDITOR_BUFFER *buffer);
void ViewsMarkChangeEnd(EDITOR_MARK *mark);
void ViewsMarkChangeStart(EDITOR_MARK *mark);
void ViewsSelectionAreaChangeEnd(EDITOR_BUFFER *buffer);
void ViewsSelectionAreaChangeStart(EDITOR_BUFFER *buffer);
void ViewsTextPieceReplaceEnd(EDITOR_BUFFER *buffer,uint64_t position,uint64_t startLength,uint64_t endLength);
void ViewsTextPieceReplaceStart(EDITOR_BUFFER *buffer,uint64_t position,uint64_t startLength,uint64_t endLength);
void ViewsTextReplaceEnd(EDITOR_BUFFER *buffer);
void ViewsTextReplaceStart(EDITOR_BUFFER *buffer);
void ViewActiveSet(EDITOR_VIEW *view,bool active);
void ViewOriginGet(EDITOR_VIEW *view,int64_t *leftPixel,int64_t *topLine);
void ViewOriginSet(EDITOR_VIEW *view,int64_t newLeftPixel,int64_t newTopLine);
void ViewDispose(EDITOR_VIEW *view);
EDITOR_VIEW *ViewCreate(EDITOR_WINDOW *window,EDITOR_VIEW_DESCRIPTOR *descriptor);
